package outilsserveur;

import java.net.*;

//  la classe Dialogue,  sous-classer avec votre classe de dialogue
public abstract class Dialogue implements Runnable {
private Socket socket;

/**
 * getSocket sera utilise uniquement dans votre dialogue,
 * donc protected
 * Creation date: (18/12/2003 16:13:51)
 * @return java.net.Socket
 */
protected java.net.Socket getSocket() {
	return socket;
}
// implmenter le run dans la sous-classe

abstract public void run();
/**
 * setSocket permet l'init par Serveur,
 * donc (package)
 * Creation date: (17/12/2003 13:54:07)
 * @param newSocket java.net.Socket
 */
void setSocket(java.net.Socket newSocket) {
	socket = newSocket;
}
/**
 * start uniquement par Serveur
 * Creation date: (17/12/2003 13:54:07)
 */
void start() {
		new Thread(this).start();
}
}
