package serveur;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.ArrayList;

public class Diffuseur implements Runnable{
	private ArrayList<Socket> _listeconnectes = null;
	FIFO _fifo = null;

	public Diffuseur()
	{
		(new Thread(this)).start();
	}
	

	public void run() {
		int i = 0;
		try{
			
			PrintWriter sOut = null;
			
			while(_listeconnectes.size() >= 0){
				String pop = (String)_fifo.pop();
				
				if(pop.startsWith("/quit ")){
					int port = Integer.parseInt(pop.substring(6, pop.indexOf("  ")));
					for(i = 0; i < _listeconnectes.size(); i++)
					{
						if(_listeconnectes.get(i).getLocalPort() == port){
							sOut = new PrintWriter(_listeconnectes.get(i).getOutputStream(), true);
							sOut.println("A bientot !");
							_listeconnectes.get(i).close();
							_listeconnectes.remove(i);
						}
					}
										
					pop = pop.substring(pop.indexOf("  ") + 3) + " a quitt le chat.";
				}
				
				for(i = 0; i < _listeconnectes.size(); i++)
				{
					sOut = new PrintWriter(_listeconnectes.get(i).getOutputStream(), true);
					//System.out.println("Envoy : " + pop);
					sOut.println(pop);
				}
			}
		}
		catch (IOException e) {
			System.err.println("Diffuseur / Erreur dans le dialogue des sockets : " + e);
		}
		finally{
			try{_listeconnectes.get(i).close();}catch(IOException e){;}
		}
				
	}
	
	
	public void setFifo(FIFO lafifo){
		_fifo = lafifo;
	}
	
	public void setListeConnectes(ArrayList learraylist){
		_listeconnectes = learraylist;
	}
	
}
	




