package serveur;

import java.util.LinkedList;

public class FIFO<String> {
	private static LinkedList _fifo = new LinkedList();
	private int _taille = 0;
	
	public FIFO()
	{
		this._taille = 0;
	}
	public FIFO(int taille){
		this._taille = taille;
	}
	
	public synchronized void push(String lastring){
		/*while(this.isFull()){
			try{
				wait();
				//if(this.isFull())throw new Exception("Liste pleine");
			}
			catch(InterruptedException e){System.out.println(e);}
		}*/
		_fifo.addLast(lastring);
		notify();
	}
	
	public synchronized String pop(){
		//System.out.println("FIFO : " + _fifo);
		while(this.isEmpty()){
			try{
				wait();
			}
			catch(InterruptedException e){
				System.out.println("Liste vide");
			}
		}
		notify();
		return (String)_fifo.removeLast();
	}
				
	
	private boolean isEmpty(){
		if(_fifo.size() == 0)return true;
		else return false;
	}
	private boolean isFull() {
		if(_fifo.size() == _taille)return true;
		else return false;
	}
	
	
}