package mesoutils;

//
//
// Keyboard
//
//
import java.io.*;

public class Keyboard 
{
private static DataInputStream keyboard=new DataInputStream(System.in);

public static char getChar()
{
	return getLine().charAt(0);
}
public static int getInt()
{
	int val;
	try{
		return Integer.parseInt(getLine());
	}catch(NumberFormatException e){ return -1;}
}
private static String getLine()
{
	String line;
	try{
		line=keyboard.readLine();
	}catch(IOException e){ return "";}
	return line;
}
public static String getString()
{
	return getLine();
}
public static void pause()
{
	try{
		keyboard.read();
	}catch(IOException e){}
}
}
